/*
   Class Name:

      CCamera.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a camera in a 3D scene.
*/


#ifndef CCAMERA_H
#define CCAMERA_H

#include<math.h>                         // Math header that allows us to use cos() and sin().
#include"CQuaternion.h"                  // Quaternion class.

#define UP              1.0f             // Forward speed.
#define DOWN            -1.0f            // Backward speed.
#define LEFT            -1.0f            // Left speed.
#define RIGHT           1.0f             // Right speed.
#define STRAFE_LEFT     1.0f             // Left straft speed.
#define STRAFE_RIGHT    -1.0f            // Right straft speed.


class CCamera
{
   public:
      CCamera();                                      // Constructor.

      void SetCamera(float x, float y, float z,       // Set the camera's position.
                     float xv, float yv, float zv,
                     float xu, float yu, float zu);

      void MoveCamera(float direction);               // Move the camera forwards and backwards.
      void UpdateCamera(float xDir, float yDir,
                        float zDir, float dir);       // Update the camera's position.
      void StrafeCam(float direction);
      void CalculateStrafe();                         // Calculate the direction of the straft.
      void RotateCamera(float AngleDir, float xSpeed, // Rotate the camera around a point.
                        float ySpeed, float zSpeed);
      void RotateByMouse(int mousePosX, int mousePosY,
                         int midX, int midY);         // Rotate camera by mouse.
      void CalculateTime();                           // Used for time based movements.

      float xPos, yPos, zPos;                         // Camera position.
      float xView, yView, zView;                      // Look at position.
      float xUp, yUp, zUp;                            // Up direction.
      float xStrafe, yStrafe, zStrafe;                // Strafe direction.
      float currentRotationAngle;                     // Keeps us from going too far up or down.
      float frameInterval;                            // Used with time based movements.
};

#endif


// Copyright September 2003
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com